-------------------------------------------------------------------------------
-- xil_idct_1_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library xil_idct_v1_00_a;
use xil_idct_v1_00_a.all;

entity xil_idct_1_wrapper is
  port (
    Clk : in std_logic;
    Reset : in std_logic;
    FSL_S_CLK : out std_logic;
    FSL_S_READ : out std_logic;
    FSL_S_DATA : in std_logic_vector(0 to 31);
    FSL_S_CONTROL : in std_logic;
    FSL_S_EXISTS : in std_logic;
    FSL_M_CLK : out std_logic;
    FSL_M_WRITE : out std_logic;
    FSL_M_DATA : out std_logic_vector(0 to 31);
    FSL_M_CONTROL : out std_logic;
    FSL_M_FULL : in std_logic
  );
end xil_idct_1_wrapper;

architecture STRUCTURE of xil_idct_1_wrapper is

  component xil_idct is
    port (
      Clk : in std_logic;
      Reset : in std_logic;
      FSL_S_CLK : out std_logic;
      FSL_S_READ : out std_logic;
      FSL_S_DATA : in std_logic_vector(0 to 31);
      FSL_S_CONTROL : in std_logic;
      FSL_S_EXISTS : in std_logic;
      FSL_M_CLK : out std_logic;
      FSL_M_WRITE : out std_logic;
      FSL_M_DATA : out std_logic_vector(0 to 31);
      FSL_M_CONTROL : out std_logic;
      FSL_M_FULL : in std_logic
    );
  end component;

begin

  xil_idct_1 : xil_idct
    port map (
      Clk => Clk,
      Reset => Reset,
      FSL_S_CLK => FSL_S_CLK,
      FSL_S_READ => FSL_S_READ,
      FSL_S_DATA => FSL_S_DATA,
      FSL_S_CONTROL => FSL_S_CONTROL,
      FSL_S_EXISTS => FSL_S_EXISTS,
      FSL_M_CLK => FSL_M_CLK,
      FSL_M_WRITE => FSL_M_WRITE,
      FSL_M_DATA => FSL_M_DATA,
      FSL_M_CONTROL => FSL_M_CONTROL,
      FSL_M_FULL => FSL_M_FULL
    );

end architecture STRUCTURE;
