module Basic_PRN ( clk, reset_b, enable, G1_serout, G2_parout);

	input clk , reset_b , enable;
	output G1_serout ;
	output [1:10] G2_parout ;
	
	reg [9:0] G1_reg ;
	reg [1:10] G2_reg ;
	wire G1_new , G2_new ;
//G1 Shift register 
	always @ ( negedge reset_b or posedge clk ) 
		if (~reset_b)
			G1_reg <= 10'h3FF ;
		else if (enable)
			G1_reg <= {G1_new,G1_reg[9:1]} ;
			
//G2 Shift register 
	always @ ( negedge reset_b or posedge clk ) 
		if (~reset_b)
			G2_reg <= 10'h3FF ;
		else if (enable)
			G2_reg <= {G2_new,G2_reg[1:9]} ;

//New values
	assign G1_new = G1_reg[7]^G1_reg[0] ;
	assign G2_new = ((G2_reg[2]^G2_reg[3])^(G2_reg[6]^G2_reg[8]))^(G2_reg[9]^G2_reg[10]) ;

//Output Assignments 
	assign G2_parout = G2_reg ;
	assign G1_serout = G1_reg[0] ;
	
endmodule