module Sat_Detector ( clk, reset_b, data_in, 
		      fifo_data_exists, load, fifo_full, fifo_out_write,
		      data_out);

	input clk, reset_b, fifo_data_exists , fifo_full;
	output load, fifo_out_write ;
	input [31:0] data_in ;
	output [9:0] data_out ;
	
	wire datain, data_feed_enable ;
	wire [4:0] mux_sel ;
	wire [9:0] cnt_out1, cnt_out2 , cnt_out3, cnt_out4, cnt_out5, cnt_out6, cnt_out7, cnt_out8 ,
		   cnt_out9, cnt_out10, cnt_out11, cnt_out12, cnt_out13, cnt_out14, cnt_out15, cnt_out16,
		   cnt_out17, cnt_out18 , cnt_out19, cnt_out20, cnt_out21, cnt_out22, cnt_out23, cnt_out24 ;

	wire [24:1] ser_out ;
	wire [10:1] par_out1, par_out2, par_out3, par_out4, par_out5, par_out6, par_out7, par_out8,
		    par_out9, par_out10, par_out11, par_out12, par_out13, par_out14, par_out15, par_out16,
		    par_out17, par_out18, par_out19, par_out20, par_out21, par_out22, par_out23, par_out24;

system_controller sat_controller (.clk(clk), .reset_b(reset_b), .data_exists(fifo_data_exists), .data_in(data_in), .shifted_data(datain), .data_out_write(fifo_out_write), .select_data(mux_sel), 
				  .data_feed_enable(data_feed_enable), .load(load), .full(fifo_full) ) ;

mux10bit_24to1 OutputFeeder (
	.MA(cnt_out1),
	.MB(cnt_out2),
	.MC(cnt_out3),
	.MD(cnt_out4),
	.ME(cnt_out5),
	.MF(cnt_out6),
	.MG(cnt_out7),
	.MH(cnt_out8),
	.MAA(cnt_out9),
	.MAB(cnt_out10),
	.MAC(cnt_out11),
	.MAD(cnt_out12),
	.MAE(cnt_out13),
	.MAF(cnt_out14),
	.MAG(cnt_out15),
	.MAH(cnt_out16),
	.MBA(cnt_out17),
	.MBB(cnt_out18),
	.MBC(cnt_out19),
	.MBD(cnt_out20),
	.MBE(cnt_out21),
	.MBF(cnt_out22),
	.MBG(cnt_out23),
	.MBH(cnt_out24),
	.S(mux_sel),
	.O(data_out));

//Satelite No. 1
	Basic_PRN satu1 ( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[1]), .G2_parout(par_out1) , .enable(data_feed_enable));
	Match_Counter counteru1 ( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[1]^(par_out1[2]^par_out1[6]))~^datain) , .cnt_out(cnt_out1) );

//Satelite No. 2
	Basic_PRN satu2 ( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[2]), .G2_parout(par_out2), .enable(data_feed_enable));
	Match_Counter counteru2 ( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[2]^(par_out2[3]^par_out2[7]))~^datain) , .cnt_out(cnt_out2) );

//Satelite No. 3
	Basic_PRN satu3 ( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[3]), .G2_parout(par_out3), .enable(data_feed_enable));
	Match_Counter counteru3 ( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[3]^(par_out3[4]^par_out3[4]))~^datain) , .cnt_out(cnt_out3) );

//Satelite No. 4
	Basic_PRN satu4 ( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[4]), .G2_parout(par_out4), .enable(data_feed_enable));
	Match_Counter counteru4 ( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[4]^(par_out4[5]^par_out4[9]))~^datain) , .cnt_out(cnt_out4) );

//Satelite No. 5
	Basic_PRN satu5 ( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[5]), .G2_parout(par_out5), .enable(data_feed_enable));
	Match_Counter counteru5 ( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[5]^(par_out5[1]^par_out5[9]))~^datain) , .cnt_out(cnt_out5) );

//Satelite No. 6
	Basic_PRN satu6 ( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[6]), .G2_parout(par_out6), .enable(data_feed_enable));
	Match_Counter counteru6 ( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[6]^(par_out6[2]^par_out6[10]))~^datain) , .cnt_out(cnt_out6) );

//Satelite No. 7
	Basic_PRN satu7 ( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[7]), .G2_parout(par_out7), .enable(data_feed_enable));
	Match_Counter counteru7 ( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[7]^(par_out7[1]^par_out7[8]))~^datain) , .cnt_out(cnt_out7) );

//Satelite No. 8
	Basic_PRN satu8 ( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[8]), .G2_parout(par_out8), .enable(data_feed_enable));
	Match_Counter counteru8 ( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[8]^(par_out8[2]^par_out8[9]))~^datain) , .cnt_out(cnt_out8) );

///////////////////////////////////////////////////////////////////////////////
//Satelite No. 9
	Basic_PRN satu9 ( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[9]), .G2_parout(par_out9), .enable(data_feed_enable));
	Match_Counter counteru9 ( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[9]^(par_out9[3]^par_out9[10]))~^datain) , .cnt_out(cnt_out9) );

//Satelite No. 10
	Basic_PRN satu10( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[10]), .G2_parout(par_out10), .enable(data_feed_enable));
	Match_Counter counteru10( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[10]^(par_out10[3]^par_out10[2]))~^datain) , .cnt_out(cnt_out10) );

//Satelite No. 11
	Basic_PRN satu11( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[11]), .G2_parout(par_out11), .enable(data_feed_enable));
	Match_Counter counteru11( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[11]^(par_out11[3]^par_out11[4]))~^datain) , .cnt_out(cnt_out11) );

//Satelite No. 12
	Basic_PRN satu12( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[12]), .G2_parout(par_out12), .enable(data_feed_enable));
	Match_Counter counteru12( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[12]^(par_out12[5]^par_out12[6]))~^datain) , .cnt_out(cnt_out12) );

//Satelite No. 13
	Basic_PRN satu13( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[13]), .G2_parout(par_out13), .enable(data_feed_enable));
	Match_Counter counteru13( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[13]^(par_out13[6]^par_out13[7]))~^datain) , .cnt_out(cnt_out13) );

//Satelite No. 14
	Basic_PRN satu14( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[14]), .G2_parout(par_out14), .enable(data_feed_enable));
	Match_Counter counteru14( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[14]^(par_out14[7]^par_out14[8]))~^datain) , .cnt_out(cnt_out14) );

//Satelite No. 15
	Basic_PRN satu15( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[15]), .G2_parout(par_out15), .enable(data_feed_enable));
	Match_Counter counteru15( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[15]^(par_out15[8]^par_out15[9]))~^datain) , .cnt_out(cnt_out15) );

//Satelite No. 16
	Basic_PRN satu16( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[16]), .G2_parout(par_out16), .enable(data_feed_enable));
	Match_Counter counteru16( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[16]^(par_out16[9]^par_out16[10]))~^datain) , .cnt_out(cnt_out16) );

///////////////////////////////////////////////////////////////////////////////
//Satelite No. 17
	Basic_PRN satu17( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[17]), .G2_parout(par_out17), .enable(data_feed_enable));
	Match_Counter counteru17( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[17]^(par_out17[1]^par_out17[4]))~^datain) , .cnt_out(cnt_out17) );

//Satelite No. 18
	Basic_PRN satu18( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[18]), .G2_parout(par_out18), .enable(data_feed_enable));
	Match_Counter counteru18( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[18]^(par_out18[2]^par_out18[5]))~^datain) , .cnt_out(cnt_out18) );

//Satelite No. 19
	Basic_PRN satu19( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[19]), .G2_parout(par_out19), .enable(data_feed_enable));
	Match_Counter counteru19( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[19]^(par_out19[3]^par_out19[6]))~^datain) , .cnt_out(cnt_out19) );

//Satelite No. 20
	Basic_PRN satu20( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[20]), .G2_parout(par_out20), .enable(data_feed_enable));
	Match_Counter counteru20( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[20]^(par_out20[4]^par_out20[7]))~^datain) , .cnt_out(cnt_out20) );

//Satelite No. 21
	Basic_PRN satu21( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[21]), .G2_parout(par_out21), .enable(data_feed_enable));
	Match_Counter counteru21( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[21]^(par_out21[5]^par_out21[8]))~^datain) , .cnt_out(cnt_out21) );

//Satelite No. 22
	Basic_PRN satu22( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[22]), .G2_parout(par_out22), .enable(data_feed_enable));
	Match_Counter counteru22( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[22]^(par_out22[9]^par_out22[6]))~^datain) , .cnt_out(cnt_out22) );

//Satelite No. 23
	Basic_PRN satu23( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[23]), .G2_parout(par_out23), .enable(data_feed_enable));
	Match_Counter counteru23( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) , .cnt_en((ser_out[23]^(par_out23[1]^par_out23[3]))~^datain) , .cnt_out(cnt_out23) );

//Satelite No. 24
	Basic_PRN satu24( .clk(clk), .reset_b(reset_b), .G1_serout(ser_out[24]), .G2_parout(par_out24), .enable(data_feed_enable));
	Match_Counter counteru24( .clk(clk), .reset_b(reset_b),.cnt_en2(data_feed_enable) ,.cnt_en((ser_out[24]^(par_out24[4]^par_out24[6]))~^datain) , .cnt_out(cnt_out24) );
endmodule