
-- VHDL Test Bench Created from source file system.vhd -- 15:29:17 10/09/2003
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
use STD.TEXTIO.all;
use work.debug.all;


library microblaze_v2_00_a;
use microblaze_v2_00_a.all;

ENTITY system_testbench_vhd_tb IS
END system_testbench_vhd_tb;

ARCHITECTURE behavior OF system_testbench_vhd_tb IS 

	COMPONENT system
 	port (
   	   sys_reset : in std_logic;
    	   sys_clk : in std_logic;
    	   rx : in std_logic;
    	   tx : out std_logic
  	);
	END COMPONENT;

	SIGNAL rx 		 :  std_logic;
	SIGNAL tx 		 :  std_logic;
	SIGNAL sys_clk   	 :  std_logic:='0';  -- init clock signal
	SIGNAL sys_reset 	 :  std_logic;

-- TYPE Array4xT IS TIME;


BEGIN

	uut: system PORT MAP(
		rx 	  => rx,
		tx 	  => tx,
		sys_clk   => sys_clk,
		sys_reset => sys_reset
	);


-- *** Test Bench start  ***

-- clock generation --> 100 MHz 

sys_clk <= not sys_clk after 5 ns;

tb : PROCESS
  BEGIN
      sys_reset <= '0'; 
      wait for 1 us;
      print("###################################");
      print("   FSL Channel Reference Design    ");
      print("   Functional Simulation start     ");
      print("###################################");
      print("");
      print("System is in Reset");
      print("");
      sys_reset <= '1';
      print("");
      print("System is out of Reset");
      print("");
      wait for 99 us;
      print("###################################");
      print("   FSL Channel Reference Design    ");
      print("  Functional Simulation completed  ");
      print("###################################");
     wait;
END PROCESS;

rx <= '0';

-- *** End Test Bench  ***

END;

-- ***** Configuration Statement  ******

configuration testbench_conf of system_testbench_vhd_tb is
  for behavior
    for uut : system
        for STRUCTURE
       	    for all : bram1_wrapper use configuration work.bram1_conf;
            end for;
        end for;
    end for;
  end for;
end testbench_conf;

